//
//  Document.m
//  Company
//
//  Created by Amin Negm-Awad on Sa.,15.09.12.
//  Copyright (c) 2012 Amin Negm-Awad. All rights reserved.
//

#import "Document.h"
#import "DocumentWindowController.h"
#import "PersonInfoWindowController.h"

@implementation Document
- (id)init
{
    self = [super init];
    if (self) {
		 self.creationDate = [NSDate date];
    }
    return self;
}

- (NSString *)windowNibName
{
	// Override returning the nib file name of the document
	// If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
	return @"Document";
}

- (void)makeWindowControllers
{
	NSString* nibName = [self windowNibName];
	DocumentWindowController* controller
	= [[DocumentWindowController alloc] initWithWindowNibName:nibName];
	[self addWindowController:controller];
	controller.shouldCloseDocument = YES;
}

- (void)showInfoWindowForObjects:(NSArray*)objects
{
	PersonInfoWindowController *infoWC;
	for (NSManagedObject *object in objects) {
		NSManagedObjectID* objectID = [object objectID];
		if( [object.entity.name isEqualToString:@"Person"] ) {
			// Alle bestehenden Window-Controller überpruefen
			NSWindowController *wc;
			for (wc in [self windowControllers]) {
				// Ist es ueberhaupt ein Person-Info-WC?
				if( ![wc isKindOfClass:[PersonInfoWindowController class]] ) {
					continue;
				}
				PersonInfoWindowController *infoWC = (PersonInfoWindowController*)wc;
				// Hat er dieselbe Person-ID?
				if( [[infoWC.person objectID] isEqualTo:objectID] ) {
					break;
				}
			}
			// Keinen gefunden, also erzeugen
			if (wc == nil) {
				infoWC = [[PersonInfoWindowController alloc]
							 initWithWindowNibName:@"PersonInfo"];
				infoWC.person = object;
				[self addWindowController:infoWC];
			} else {
				infoWC = (PersonInfoWindowController*)wc;
			}
			NSLog( @"%@ %d", infoWC.window, [[infoWC window] canBecomeKeyWindow]);
			[[infoWC window] makeKeyAndOrderFront:self];
		}
	}
}

- (void)windowControllerDidLoadNib:(NSWindowController *)aController
{
	[super windowControllerDidLoadNib:aController];
	// Add any code here that needs to be executed once the windowController has loaded the document's window.
}

+ (BOOL)autosavesInPlace
{
    return YES;
}

@end
