//
//  PersonInfoWindowController.m
//  Company
//
//  Created by Amin Negm-Awad on Mo.,17.09.12.
//  Copyright (c) 2012 Amin Negm-Awad. All rights reserved.
//

#import "PersonInfoWindowController.h"
#import "DocumentWindowController.h"

@interface PersonInfoWindowController ()
@property (strong, readwrite) NSManagedObject *person;
@end

@implementation PersonInfoWindowController
- (void)personDeleted:(NSNotification*)notification
{
	id _self = self;
	[self.document removeWindowController:self];
	// Ab hier wird self nur noch von _self gehalten!
	_self = nil;
}

- (void)windowWillClose:(NSNotification *)notification
{
	NSNotificationCenter *center = [NSNotificationCenter defaultCenter];
	[center removeObserver:self];
}

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (id)initWithWindowNibName:(NSString*)nibName forPerson:(NSManagedObject *)person
{
	self = [super initWithWindowNibName:nibName];
	if (self) {
		self.person = person;
	}
	return self;
}

- (void)windowDidLoad
{
    [super windowDidLoad];
   [super windowDidLoad];
	NSNotificationCenter *center = [NSNotificationCenter defaultCenter];
	[center addObserver:self selector:@selector (personDeleted:)
						name:personDeletionNotification object:self.person];
}
@end
