//
//  AppDelegate.m
//  Container
//
//  Created by Amin Negm-Awad on Mo.,11.03.13.
//  Copyright (c) 2013 Amin Negm-Awad. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate
- (void)switchTextFieldToDecimalNumbers:(NSTextField*)textField
{
	NSCell *cell = textField.cell;
	NSFormatter *formatter = cell.formatter;
	if ([formatter isKindOfClass:[NSNumberFormatter class]]) {
		NSNumberFormatter *numberFormatter = (NSNumberFormatter*)formatter;
		numberFormatter.generatesDecimalNumbers = YES;
	}
}

- (IBAction)calculate:(id)sender
{
	NSDecimalNumber *input = self.inputTextField.objectValue;
	NSDecimalNumber *factor = self.factorTextField.objectValue;
	NSDecimalNumber *output;
	
	if (input==nil) {
		output = [NSDecimalNumber notANumber];
	} else if (factor == nil)
	{
		output = [NSDecimalNumber notANumber];
	} else {
		output = [input decimalNumberByMultiplyingBy:factor];
	}
	
	self.outputTextField.objectValue = output;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	[self switchTextFieldToDecimalNumbers:self.inputTextField];
	[self switchTextFieldToDecimalNumbers:self.factorTextField];
	[self switchTextFieldToDecimalNumbers:self.outputTextField];
	
}

@end
