//
//  Converter.m
//  Converter
//
//  Created by Amin Negm-Awad on Di.,04.09.12.
//  Copyright (c) 2012 Amin Negm-Awad. All rights reserved.
//

#import "Converter.h"

@implementation Converter
- (IBAction)calculate:(id)sender
{
	double input = [self.inputTextField doubleValue];
	double factor = [self.factorTextField doubleValue];
	double result = input * factor;
	[self.outputTextField setDoubleValue:result];
}

- (void)displayExitCode:(NSInteger)exitCode inButton:(NSButton*)button
{
	switch( exitCode ) {
		case NSAlertFirstButtonReturn:
			button.title = @"Der erste";
			break;
		case NSAlertSecondButtonReturn:
			button.title = @"Der zweite";
			break;
		default:
			break;
	}
}

- (void)alertDidEnd:(NSAlert*)alert
			returnCode:(NSInteger)exitCode
		  contextInfo:(void*)context
{
	NSButton *button = (__bridge NSButton*)context;
	[self displayExitCode:exitCode inButton:button];
}

- (IBAction)playWithViews:(id)sender
{
	// Eine Alert erzeugen
	NSAlert *alert = [[NSAlert alloc] init];

	// Buttons hinzufuegen
	[alert addButtonWithTitle:@"Jein"];
	[alert addButtonWithTitle:@"Vielleicht"];
	
	// Text hinzufuegen
	[alert setMessageText:@"Möchten Sie das wirklich nicht tun?"];
	[alert setInformativeText:@"Kein Undo verfügbar."];
	
	// Symbol setzen
	[alert setAlertStyle:NSWarningAlertStyle];
	
	// Alert ausführen:
	SEL callback = @selector(alertDidEnd:returnCode:contextInfo:);
	[alert beginSheetModalForWindow:[sender window]
							modalDelegate:self
						  didEndSelector:callback
							  contextInfo:(__bridge void*)sender];
	[sender setTitle:@"Sheet in Progress"];
}

@end
