//
//  Converter.m
//  Converter
//
//  Created by Amin Negm-Awad on Di.,04.09.12.
//  Copyright (c) 2012 Amin Negm-Awad. All rights reserved.
//

#import "Converter.h"

@implementation Converter
- (IBAction)calculate:(id)sender
{
	double input = [self.inputTextField doubleValue];
	double factor = [self.factorTextField doubleValue];
	double result = input * factor;
	[self.outputTextField setDoubleValue:result];
}

- (void)displayExitCode:(NSInteger)exitCode inButton:(NSButton*)button
{
	switch( exitCode ) {
		case NSAlertFirstButtonReturn:
			button.title = [self.dataTextField stringValue];;
			break;
		case NSAlertSecondButtonReturn:
			button.title = @"Abgebrochen";
			break;
		default:
			break;
	}
}

- (void)alertDidEnd:(NSAlert*)alert
			returnCode:(NSInteger)exitCode
		  contextInfo:(void*)context
{
	NSButton *button = (__bridge NSButton*)context;
	[self displayExitCode:exitCode inButton:button];
}

- (IBAction)playWithViews:(id)sender
{
	NSInteger exitCode;
	exitCode = [[NSApplication sharedApplication] runModalForWindow:self.sheet];
	[self displayExitCode:exitCode inButton:sender];
	[self.sheet close];
}

-(IBAction)cancelButtonClicked:(id)sender
{
	[NSApp stopModalWithCode:NSAlertSecondButtonReturn];
}

-(IBAction)performButtonClicked:(id)sender
{
	if ([[self.dataTextField stringValue] length] > 0) {
		[NSApp stopModalWithCode:NSAlertFirstButtonReturn];
	} else {
		NSBeep();
	}
}
@end
