//
//  Instrument.m
//  ObjectiveC
//
//  Created by Amin Negm-Awad on Mo.,14.01.13.
//  Copyright (c) 2013 Amin Negm-Awad. All rights reserved.
//

#import "Instrument.h"

@implementation Instrument
- (void)growOld
{
	self.age = self.age + 1;
	self.price = self.price * 0.9;
}

- (void)play
{
	NSLog(@"Playing");
}

- (id)copyWithZone:(NSZone *)zone
{
	Instrument *copy = [[[self class] allocWithZone:zone] init];
	copy.name = self.name;
	copy.age = self.age;
	copy.price = self.price;
	
	return copy;
}

- (BOOL)isEqualToInstrument:(Instrument*)instrument
{
	return    [self.name isEqualToString:instrument.name]
		   && (self.age == instrument.age)
 	       && (self.price == instrument.price);
}

- (BOOL)isEqual:(id)object
{
	if ([object isKindOfClass:[Instrument class]]) {
		return [self isEqualToInstrument:object];
	}
	else
	{
		return NO;
	}
}

- (id)initWithName:(NSString*)name age:(NSInteger)age price:(NSInteger)price
{
	//	Zunächst Initialisierung der Superklasse ausführen
	self = [super init];
	
	//	Bei Erfolg …
	if (self) {
		//	… eigene Instanzvariablen setzen
		self.name = name;
		self.age = age;
		self.price = price;
	}
	return self;
}

 -(id)initWithName:(NSString *)name price:(NSInteger)price
{
	return [self initWithName:name age:0 price:price];
}

- (id)init
{
	return [self initWithName:@"Any Instrument" age:0 price:0];
}

+ (id)instrumentWithName:(NSString*)name
					 age:(NSInteger)age
				   price:(NSInteger)price
{
	return [[self alloc] initWithName:name age:age price:price];
}

+ (id)instrumentWithName:(NSString*)name price:(NSInteger)price
{
	return [[self alloc] initWithName:name price:price];
}

@end
